## acl2 8.5dfsg

=== books/clause-processors/SULFA/Makefile ===
# Matt K. comment 4/22/2017: The following sort of "make" doesn't seem
# to work directly for me.  However, things work fine when using "make
# regression" in the main ACL2 directory.
# make ACL2_SYSTEM_BOOKS=/projects/acl2/v3-2-linux/books ACL2=/projects/acl2/v3-2-linux/allegro-saved_acl2

# Your Perl interpreter
PERL ?= perl

# Your SAT solver executable
SAT_SOLVER ?= ${PWD}/../../../aux/minisat2/${HOSTTYPE}/minisat/core/minisat

# Either "minisat" or "zchaff"
SAT_SOLVER_TYPE ?= minisat

#Or, for example:
#SAT_SOLVER = ${PWD}/../../../sat-solvers/zchaff/zchaff
#SAT_SOLVER_TYPE = zchaff

# Your C compiler
CC = gcc

ACL2_SYSTEM_BOOKS ?= $(shell cd ../.. ; pwd)

# I need a full path so that I can hardcode a call to
# ACL2 in our SULFA smt solver.
ACL2 ?= ${PWD}/${ACL2_SYSTEM_BOOKS}/../saved_acl2

# I want the defaults set in this makefile to carry over into
# subdirectories.
MAKE += PERL=${PERL} SAT_SOLVER=${SAT_SOLVER} SAT_SOLVER_TYPE=${SAT_SOLVER_TYPE} CC=${CC}

DIRS = scripts c-files books

all: check_sat_exec check_sat_type scripts/sulfa-smt

.PHONY: check_sat_type
check_sat_type:
	@if [ $(SAT_SOLVER_TYPE) != "minisat" -a \
              $(SAT_SOLVER_TYPE) != "zchaff" ]; then \
          echo "Illegal SAT_SOLVER_TYPE: '$(SAT_SOLVER_TYPE)'"; \
          exit 1; \
        fi

.PHONY: check_sat_exec
check_sat_exec:
	@if [ ! -f $(SAT_SOLVER) ] ; then \
	  echo "Unable to find sat solver file: '$(SAT_SOLVER)'" ; \
	  exit 1 ; \
	fi

scripts/sulfa-smt: subdirs scripts/interpret_sulfa_file

scripts/sulfa-smt:
	@${MAKE} sulfa-smt -C scripts

subdirs: scripts/interpret_sulfa_file

subdirs:
	@for dir in ${DIRS}; do \
       ${MAKE} -C $$dir; \
        done

.PHONY: subdirs

scripts/interpret_sulfa_file:
	@echo "#!${PERL}" > scripts/interpret_sulfa_file ; \
echo "" >> scripts/interpret_sulfa_file ; \
echo "# WARNING: DO NOT MODIFY THIS FILE DIRECTLY, IT'S GENERATED USING the top-level makefile!" >> scripts/interpret_sulfa_file ; \
echo "while ("'$$'"line = <>) {"  >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s,%SULFA_DIR%,${CURDIR},;" >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s,%PERL%,${PERL},;" >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s,%ACL2%,${ACL2},;" >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s,%SAT_SOLVER%,${SAT_SOLVER},;" >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s,%SAT_SOLVER_TYPE%,${SAT_SOLVER_TYPE},;" >> scripts/interpret_sulfa_file ; \
echo "" >> scripts/interpret_sulfa_file ; \
echo '$$'"line =~ s/%CREATE_GENERATED_WARNING%/WARNING: DO NOT MODIFY THIS FILE DIRECTLY, IT'S GENERATED FROM ANOTHER FILE BY USING interpret_sulfa_file!/;" >> scripts/interpret_sulfa_file ; \
echo "print "'$$'"line;" >> scripts/interpret_sulfa_file ; \
echo "}" >> scripts/interpret_sulfa_file ; \
echo "" >> scripts/interpret_sulfa_file ; \
chmod ugo+rx-w scripts/interpret_sulfa_file

clean:
	rm -f \#*\# *~
	rm -f scripts/interpret_sulfa_file
	${MAKE} clean-subdirs

clean-subdirs:
	for dir in ${DIRS}; do \
        ${MAKE} clean -C $$dir; \
        done

.PHONY: clean-subdirs

=== books/coi/types/Makefile ===
ACL2_SYSTEM_BOOKS ?= ../..

all:
	${ACL2_SYSTEM_BOOKS}/build/cert.pl *.lisp

clean:
	${ACL2_SYSTEM_BOOKS}/build/clean.pl

=== books/projects/dpss/Makefile ===
all:
	cd Util; make
	cd Base; make
	cd AvD; make
	cd Collins; make

clean:
	cd Util; make clean
	cd Base; make clean
	cd AvD; make clean
	cd Collins; make clean

=== books/projects/rac/Makefile ===
export ACL2?=${ACL2_DIR}/saved_acl2
export RAC?=${ACL2_DIR}/books/projects/rac

all:
	(cd src; make all)
	(cd lisp; make all)

clean:
	(cd lisp; make clean)
	(cd src; make clean)
	(cd examples; make clean)

veryclean: clean
	(cd lisp; make veryclean)
	(cd src; make veryclean)
	(cd examples; make veryclean)

=== books/projects/x86isa/Makefile ===
# X86ISA Library
#
# Note: The license below is based on the template at:
# http://opensource.org/licenses/BSD-3-Clause
#
# Copyright (C) 2015, Regents of the University of Texas
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# o Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# o Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the distribution.
#
# o Neither the name of the copyright holders nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Original Author(s):
# Shilpi Goel         <shigoel@cs.utexas.edu>

# Usage:

# make JOBS=2 \
#      X86ISA_EXEC=t \
#      ACL2=<Path of the ACL2 image>

#======================================================================
.PHONY: all model tools write_exec_fn top execclean clean
#======================================================================

ifndef ACL2
 $(error Variable ACL2 is undefined.)
endif

BUILD_DIR := $(dir $(ACL2))books/build
CC ?= gcc
X86ISA_EXEC ?= t
JOBS ?= 2

#======================================================================

ifeq ($(X86ISA_EXEC), t)

PLATFORM = $(shell uname | tr a-z A-Z)

ifeq ($(findstring LINUX,$(PLATFORM)), LINUX)
 SYSCALL_LIB := machine/shared/libsyscallutils.so
 X86ISA_EXEC_CERTS = $(SYSCALL_LIB)
# PROOF_BOOKS += $(LINUX_BOOKS)
endif # ifeq ($(findstring LINUX,$(PLATFORM)), LINUX)

ifeq ($(findstring DARWIN,$(PLATFORM)), DARWIN)
 SYSCALL_LIB := machine/shared/libsyscallutils.dylib
 X86ISA_EXEC_CERTS = $(SYSCALL_LIB)
# PROOF_BOOKS += $(DARWIN_BOOKS)
endif # ifeq ($(findstring DARWIN,$(PLATFORM)), DARWIN)

# Note that X86ISA_EXEC_CERTS will be empty if we are on a machine
# other than Darwin or Linux. Currently, for FreeBSD machines, we do
# not have full execution support (i.e., SYSCALLS in programmer-level
# mode will not be simulated.)

X86ISA_FULL_EXEC_SUPPORT_EXISTS := $(wildcard machine/x86isa_full_exec_support.lisp)
X86_SYSCALLS_ACL2_EXISTS := $(wildcard machine/syscalls.acl2)

ifneq ($(X86ISA_EXEC_CERTS), )
ifneq ($(X86ISA_FULL_EXEC_SUPPORT_EXISTS), machine/x86isa_full_exec_support.lisp)
ifneq ($(X86_SYSCALLS_ACL2_EXISTS), machine/syscalls.acl2)
 X86ISA_EXEC_CERTS += write_exec_fn
endif # ifneq ($(X86_SYSCALLS_ACL2_EXISTS), machine/syscalls.acl2)
endif # ifneq ($(X86ISA_FULL_EXEC_SUPPORT_EXISTS), machine/x86isa_full_exec_support.lisp)
endif # ifneq ($(X86ISA_EXEC_CERTS), )
endif # ifeq ($(X86ISA_EXEC), t)

#======================================================================

all: $(X86ISA_EXEC_CERTS) top

model: $(X86ISA_EXEC_CERTS)
	@${info X86ISA_EXEC       := $(X86ISA_EXEC)}
	@${info X86ISA_EXEC_CERTS := $(X86ISA_EXEC_CERTS)}
	@${info Building the x86 ISA model...}
	$(BUILD_DIR)/cert.pl -j $(JOBS) machine/x86

tools: model
	@${info Building tools to enable concrete simulation of x86 programs...}
	$(BUILD_DIR)/cert.pl -j $(JOBS) tools/execution/top

write_exec_fn: # Here only when X86ISA_EXEC=t, X86ISA_EXEC_CERTS is not empty, and if generated files don't exist already	
	@${info Including the following C shared libraries: $(SYSCALL_LIB)}
	@echo ';; File contents generated during the make process:' > machine/x86isa_full_exec_support.lisp 
	@echo '(in-package "X86ISA")' >> machine/x86isa_full_exec_support.lisp
	@echo '(defun x86isa_syscall_exec_support () 42)' >> machine/x86isa_full_exec_support.lisp 
	@${info machine/x86isa_full_exec_support.lisp created to support X86ISA_EXEC=$(X86ISA_EXEC).} 
	@${info Do not add machine/x86isa_full_exec_support.lisp to the repository!} 
	@cp machine/cert.acl2 machine/syscalls.acl2
	@echo '(ld "x86isa_full_exec_support.lisp" :ld-missing-input-ok t)' >> machine/syscalls.acl2 
	@${info machine/syscalls.acl2 created to support X86ISA_EXEC=$(X86ISA_EXEC).} 
	@${info Do not add machine/syscalls.acl2 to the repository!} 
	@${info Remember to do 'make execclean' if you wish to build with X86ISA_EXEC=nil.} 
	@${info ----------------------------------------------------------------------} 

machine/shared/libsyscallutils.dylib: machine/shared/syscall-utils.c
	$(CC) -m64 -dynamiclib -Wall -o machine/shared/libsyscallutils.dylib \
	     machine/shared/syscall-utils.c

machine/shared/libsyscallutils.so: machine/shared/syscall-utils.c
	$(CC) -c -Wall -Werror -fpic -o machine/shared/syscall-utils.o \
				      machine/shared/syscall-utils.c
	$(CC) -shared -o machine/shared/libsyscallutils.so machine/shared/syscall-utils.o

top: $(X86ISA_EXEC_CERTS)
	@${info X86ISA_EXEC       := $(X86ISA_EXEC)}
	@${info X86ISA_EXEC_CERTS := $(X86ISA_EXEC_CERTS)}
	$(BUILD_DIR)/cert.pl -j $(JOBS) top

execclean:
	rm -f machine/syscalls.cert
	rm -f machine/x86-other-non-det.cert
	rm -f machine/x86isa_full_exec_support.*
	rm -f machine/syscalls.acl2
	rm -f $(SYSCALL_LIB)
	rm -rf machine/shared/*.o

clean:
	$(BUILD_DIR)/clean.pl
	rm -f machine/x86isa_full_exec_support.*
	rm -f machine/syscalls.acl2
	rm -f $(SYSCALL_LIB)
	rm -rf machine/shared/*.o

#======================================================================

=== books/centaur/sv/cosims/Makefile ===
# SV - Symbolic Vector Hardware Analysis Framework
# Copyright (C) 2014-2015 Centaur Technology
# Copyright (C) 2022 Intel Corporation
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Sol Swords <sswords@centtech.com>

.PHONY: all

all:

# ---------------------------------------
#  Building the cosim image

STARTJOB ?= $(SHELL)
ACL2 ?= acl2

# For any extra VCS/NCVerilog flags
VCS_FLAGS ?=
NCV_FLAGS ?=

CORE := ./cosim-core
IMG_EXT ?= lx86cl64

ACL2_SYSTEM_BOOKS ?= ../../..

$(info Rebuilding Makefile-books...)
REBUILD_MAKEFILE_BOOKS := $(shell \
	$(ACL2_SYSTEM_BOOKS)/build/cert.pl cosims.lisp \
		--quiet \
		--static-makefile Makefile-books \
		--var-prefix BOOKS_TOP; \
        ls -l Makefile-books ;\
	)
$(info $(REBUILD_MAKEFILE_BOOKS))
$(info Done rebuilding makefiles)

-include Makefile-books

cosim-core: cosims.cert make-cosim.lsp
	@rm -f $(CORE)
	@$(STARTJOB) -c "$(ACL2) < make-cosim.lsp &> make-cosim.out"
	@ls -l cosim-core

all: cosim-core symlinks

.PHONY: symlinks

# ------------------------------------------
#  Test setup.
FAILING_TEST_TARGETS := \
  task/ok \
  task2/ok \
  case_wilds/ok \
  gates_cmos/ok \
  gates_pmos/ok \
  gates_nmos/ok \
  gates_rpmos/ok \
  gates_rnmos/ok \
  gates_pullup/ok \
  gates_pulldown/ok \
  inst_size1/ok \
  inst_size2/ok \
  inst_size3/ok \
  inst_size4/ok \
  sqrt/ok \
  udp_wide1/ok \
  fns3/ok \
  bind5/ok \
  float1/ok \
  paramtypes3/ok \
  paramtypes4/ok \
  iface_basic7/ok \
  pluscolon/ok \
  bin_inside1/ok \
  bin_inside2/ok \
  bin_inside3/ok \
  stream3/ok \
  stream4/ok \
  nonblkloop2/ok \
  dynwrite/ok \
  undriven/ok \
  alwaysmulti/ok

# VL/SV is in several ways more conservative than VCS when instance
# port expressions don't match the port sizes.  

# The inside operator in VL/SV follows the old VCS behavior in that it
# compares the test element pairwise with each set element, whereas
# new versions of VCS instead match the NCV behavior of
# extending/signing all elements together before comparing.

# Streaming concatenations as LHSes are broken in that if the assigned
# expression's size is greater than the number of bits in the LHS, the
# least-significant bits will be used, whereas the spec says the
# most-significant bits will be used.

SPECFILES := $(wildcard */spec.sv)
TESTS := $(patsubst %/spec.sv,%,$(SPECFILES))
TESTCERTS := $(patsubst %,%/ok,$(TESTS))
OUTDATAS_NCV := $(patsubst %,%/outputs.ncv.data,$(TESTS))
OUTDATAS_VCS := $(patsubst %,%/outputs.vcs.data,$(TESTS))
OUTDATAS_IV  := $(patsubst %,%/outputs.iv.data,$(TESTS))

PASSING_TESTS := $(filter-out $(FAILING_TEST_TARGETS), $(TESTCERTS))
OUTDIRS_VCS := $(patsubst %,%/simv.daidir,$(TESTS))
print_tests :
	@echo $(TESTS)

ifneq ($(NO_NCV),1)
NCV_PAT := %/outputs.ncv.data
else
NCV_PAT :=
endif

ifneq ($(NO_VCS),1)
VCS_PAT := %/outputs.vcs.data
else
VCS_PAT :=
endif

ifneq ($(NO_IV),1)
IV_PAT := %/outputs.iv.data
else
IV_PAT :=
endif

# %/ok : %/outputs.ncv.data %/outputs.vcs.data %/outputs.iv.data cosim-core
%/ok : $(NCV_PAT) $(VCS_PAT) $(IV_PAT) cosim-core
	@echo "Making $*/ok"
	@rm -f $*.ok $*/cosim.out
	COSIM_TESTDIR=$* $(STARTJOB) -c "./cosim-core < run.lsp &> $*/cosim.out"
	@! egrep "Test failed|ACL2 Error" $*/cosim.out > /dev/null
	@mv $*/cosim.out $*/ok
	@ls -l $*/ok

%/outputs.ncv.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.ncv.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
	 elif [ -e threevalued ]; then \
	   infile=../threevalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_ncv ]; then \
		touch outputs.ncv.data; \
         else \
		ncverilog $(NCV_FLAGS) -sv spec.sv ../test.sv +define+infile=\"$$infile\" +define+outfile=\"outputs.ncv.data\" +define+test_define=3 +test_is_$* ; \
	 fi
	@ls -l $*/outputs.ncv.data

%/outputs.vcs.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.vcs.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
	 elif [ -e threevalued ]; then \
	   infile=../threevalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_vcs ]; then \
		touch outputs.vcs.data; \
	 else \
		 vcs $(VCS_FLAGS) -sverilog spec.sv ../test.sv +define+infile=\"$$infile\" +define+outfile=\"outputs.vcs.data\" +define+test_define=3 +test_is_$* && ./simv; \
	 fi
	@ls -l $*/outputs.vcs.data

%/outputs.iv.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.iv.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
	 elif [ -e threevalued ]; then \
	   infile=../threevalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_iv ]; then \
		touch outputs.iv.data; \
	 else \
		 iverilog -g2012 spec.sv ../test.sv -Dinfile=\"$$infile\" -Doutfile=\"outputs.iv.data\" && ./a.out; \
	 fi
	@ls -l $*/outputs.iv.data

.PHONY: ncv
ncv : $(OUTDATAS_NCV)

.PHONY: vcs
vcs : $(OUTDATAS_VCS)

.PHONY: iv
iv  : $(OUTDATAS_IV)

.PHONY: passing
passing : $(PASSING_TESTS)

.phony: failing
failing: $(FAILING_TEST_TARGETS)

# all : $(TESTCERTS) ncv vcs iv
all : $(TESTCERTS)

.PHONY: cleansim
cleansim:
	rm -f $(OUTDATAS_NCV) $(OUTDATAS_VCS) $(OUTDATAS_IV)
	rm -rf $(OUTDIRS_VCS)
	rm -rf */INCA_libs
	rm -rf */csrc
	rm -rf */simv.daidir
	rm -f */simv
	rm -f */a.out
	rm -f */irun.history */ncverilog.history
	rm -f */ncverilog.log
	rm -f */test.vcd
	rm -f */ucli.key
	rm -f */ok

.PHONY: clean
clean: cleansim

# [Jared] hack so you can just write "make always1" or similar, adapted
# from vl linttests

.PHONY: $(TESTS)

define mkDirTarget
$(1): $(1)/ok
endef

$(foreach dir, $(TESTS), $(eval $(call mkDirTarget, $(dir))))

=== books/centaur/ubdds/slides/Makefile ===
.PHONY: all clean clean-all

all: ubdds.pdf ubdds-4up.pdf

ubdds.pdf: ubdds.tex
	pdflatex $< $@

ubdds-4up.ps: ubdds.ps
	psnup -nup 4 -l ubdds.ps > ubdds-4up.ps

ubdds-4up.pdf: ubdds-4up.ps
	ps2pdf ubdds-4up.ps ubdds-4up.pdf

ubdds.ps: ubdds.pdf
	pdf2ps ubdds.pdf ubdds.temp.ps
	psnup -1 -W128mm -H96mm -pletter ubdds.temp.ps ubdds.ps
	rm -f ubdds.temp.ps

clean:
	rm -f *.log *.dvi *.aux *.temp.* *.nav *.snm *.out *.toc *.vrb *~

clean-all: clean
	rm -f ubdds.pdf ubdds.ps ubdds-4up.ps ubdds-4up.pdf

=== books/centaur/vl2014/failtest/Makefile ===
# VL 2014 -- VL Verilog Toolkit, 2014 Edition
# Copyright (C) 2008-2015 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean

STARTJOB ?= bash
VL       ?= $(PWD)/../bin/vl2014

SPEC_FILES := $(wildcard *.v)
VOK_FILES  := $(patsubst %.v, %.vok,  $(SPEC_FILES))
SVOK_FILES := $(patsubst %.v, %.svok, $(SPEC_FILES))



%.vok: %.v $(VL)
	echo "Making $*.ok"
	rm -f $*.vok
	$(STARTJOB) -c "$(VL) model $*.v --mem=2 --search=. --mustfail=top --edition=Verilog --model-file=$*.v.model.sao --esims-file=$*.v.esims.sao --verilog-file=$*.v.pp &> $*.vok.log"
	rm $*.v.esims.sao $*.v.model.sao $*.v.model.sao.ver $*.v.pp
	cp $*.vok.log $*.vok
	ls -l $*.vok

%.svok: %.v $(VL)
	echo "Making $*.svok"
	rm -f $*.svok
	$(STARTJOB) -c "$(VL) model $*.v --mem=2 --search=. --mustfail=top --edition=SystemVerilog --model-file=$*.sv.model.sao --esims-file=$*.sv.esims.sao --verilog-file=$*.sv.pp &> $*.svok.log"
	rm $*.sv.esims.sao $*.sv.model.sao $*.sv.model.sao.ver $*.sv.pp
	cp $*.svok.log $*.svok
	ls -l $*.svok

all: $(VOK_FILES) $(SVOK_FILES)



clean:
	rm -f *.vok *.svok *.log *.sao *.pp *.sao.ver
	rm -rf csrc INCA_libs simv.daidir
	rm -f simv ucli.key *.log

=== books/kestrel/java/aij/Makefile ===
# Java Library
#
# Copyright (C) 2021 Kestrel Institute (http://www.kestrel.edu)
#
# License: A 3-clause BSD license. See the LICENSE file distributed with ACL2.
#
# Author: Alessandro Coglio (coglio@kestrel.edu)

################################################################################

# This file compiles the Java source files of AIJ without IntelliJ IDEA.
# It generates the class and jar files in the same places as IntelliJ IDEA does.

# This file also generates Javadoc HTML documentation
# for public, package-private, and private classes and members
# (not for protected classes and members
# because AIJ currently does not have any).
# The generated documentation goes into the directories
# javadoc-public, javadoc-package, and javadoc-private,
# from where it can be opened in a browser.

# This file also certifies the ACL2 files in this directory.
# Note that the ACL2 files do not depend on the Java-related files,
# and that the Java-related files do not depend on the ACL2 files.
# This file does not assume cert.pl and clean.pl to be in the path:
# it references them via a relative path from this directory.

# This file assumes that
# a Java 8 (or later) compiler and related tools (e.g. the latest OpenJDK)
# is in the path.
# We compile the file requiring the source to be Java 8,
# and ensuring that the class files are Java 8.

################################################################################

$(info ) # print a blank line

all: aij javadoc-all acl2-files

aij: java/out/artifacts/AIJ_jar/AIJ.jar

java/out/artifacts/AIJ_jar/AIJ.jar: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate class files:"
	mkdir -p java/out/production/AIJ
	javac -target 8 -source 8 -d java/out/production/AIJ java/src/edu/kestrel/acl2/aij/*.java
	@echo ""
	@echo "Generate jar file:"
	mkdir -p java/out/artifacts/AIJ_jar
	jar cfm java/out/artifacts/AIJ_jar/AIJ.jar java/META-INF/MANIFEST.MF \
            -C java/out/production/AIJ/ .
	@echo ""

javadoc-all: javadoc-public javadoc-package javadoc-private

javadoc-public: javadoc-public/index.html

javadoc-package: javadoc-package/index.html

javadoc-private: javadoc-private/index.html

javadoc-public/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate public Javadoc documentation:"
	javadoc -d javadoc-public -public java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-package/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate package Javadoc documentation:"
	javadoc -d javadoc-package -package java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-private/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate private Javadoc documentation:"
	javadoc -d javadoc-private -private java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

acl2-files: top.cert

top.cert: top.lisp
	@echo "Certify ACL2 files:"
	../../../build/cert.pl *.lisp
	@echo ""

clean:
	@echo "Delete class files and jar file:"
	/bin/rm -rf java/out
	@echo ""
	@echo "Delete Javadoc HTML files:"
	/bin/rm -rf javadoc-public
	/bin/rm -rf javadoc-package
	/bin/rm -rf javadoc-private
	@echo ""
	@echo "Delete ACL2 certification files:"
	../../../build/clean.pl
	@echo ""

=== books/projects/arm/utils/Makefile ===
# Cuong Chau <ckc8687@gmail.com>

# June 2021

# Usage:

# make JOBS=4 \
#      ACL2=<Path of the ACL2 image>

# To remove certificate files, etc., execute the following:
#
# make clean ACL2=<Path of the ACL2 image>

#======================================================================
.PHONY: all clean
#======================================================================

ifndef ACL2
 $(error Variable ACL2 is undefined.)
endif

BUILD_DIR := $(dir $(ACL2))books/build
JOBS ?= 4

#======================================================================

all:
	$(BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) *.lisp

clean:
	$(BUILD_DIR)/clean.pl

=== books/projects/async/telescope/Makefile ===
# Copyright (C) 2019, Regents of the University of Texas
# Written by Cuong Chau <ckcuong@cs.utexas.edu>
# License: A 3-clause BSD license.  See the LICENSE file distributed with
# ACL2.

# Usage:

# make JOBS=4 \
#      ACL2=<Path of the ACL2 image>

# To remove certificate files, etc., execute the following:
#
# make clean ACL2=<Path of the ACL2 image>

#======================================================================
.PHONY: all clean
#======================================================================

ifndef ACL2
 $(error Variable ACL2 is undefined.)
endif

BUILD_DIR := $(dir $(ACL2))books/build
JOBS ?= 4

#======================================================================

all:
	$(BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) *.lisp

clean:
	$(BUILD_DIR)/clean.pl

=== books/projects/dpss/Collins/Makefile ===
ACL2_SYSTEM_BOOKS ?= ../../..

all:
	${ACL2_SYSTEM_BOOKS}/build/cert.pl *.lisp

%.cert : %.lisp
	${ACL2_SYSTEM_BOOKS}/build/cert.pl $*.lisp

clean:
	${ACL2_SYSTEM_BOOKS}/build/clean.pl

=== debian/changelog ===
acl2 (8.5dfsg-6) unstable; urgency=medium

  * Bug fix: "needs rebuild against dh-elpa &gt;=2.1.5", thanks to
    spwhitton@spwhitton.name</a>; (Closes: #1077092).

 -- Camm Maguire <camm@debian.org>  Sun, 28 Jul 2024 12:08:41 -0400

acl2 (8.5dfsg-5) unstable; urgency=medium

  * relieve memory pressure in build via GCL_MEM_MULTIPLE=0.1

 -- Camm Maguire <camm@debian.org>  Sun, 15 Jan 2023 20:02:50 -0500

acl2 (8.5dfsg-4) unstable; urgency=medium

  * build depend latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 08 Jan 2023 17:09:23 -0500

acl2 (8.5dfsg-3) unstable; urgency=medium

  * build depend latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 25 Dec 2022 18:10:20 -0500

acl2 (8.5dfsg-2) unstable; urgency=medium

  * Bug fix: "FTBFS: make: *** [debian/rules:160: infix-stamp] Error 2", thanks to Lucas Nussbaum (Closes: #1026795).
  * build depend latest gcl
  * remove superfluous tex-common from build-deps

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 10:43:39 -0500

acl2 (8.5dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bug fix: "Please remove dependency on install-info", thanks to Hilmar
    Preusse (Closes: #1013453).

 -- Camm Maguire <camm@debian.org>  Wed, 27 Jul 2022 09:42:51 -0400

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper-compat ( = 13 ), gcl ( >= 2.6.14-1), debhelper ( >= 13), texlive-latex-recommended, time, texinfo
Build-Depends-Indep: dh-elpa
Homepage: https://www.cs.utexas.edu/users/moore/acl2/
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: elpa-acl2
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary.

Package: acl2-source
Architecture: all
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: elpa-acl2
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs-gtk | emacsen, ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Section: lisp
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4)
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

# ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION:=500000000
# MAXJOBS:=$(shell gcl -batch -eval \
#    "(print \
#       (multiple-value-bind (a b c d) (si::heap-report) \
# 	(min 8 \
# 	     (ceiling (/ (- d c) (/ a 8)) \
#                       ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}))))")

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
# NUMJOBS:=$(shell if test $(NUMJOBS) -gt ${MAXJOBS}; then echo ${MAXJOBS} ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori:
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/elpa-acl2.elpa: debian/acl2-pkg.el
	find books/interface/emacs -name "*.el" >$@
	find emacs -name "*.el" >>$@
	find books/xdoc -name "*.el" >>$@
	find books/system/doc -name "*.el" >>$@
	find books/emacs -name "*.el" >>$@
	echo debian/acl2.el >> debian/elpa-acl2.elpa
	echo debian/acl2-pkg.el >> debian/elpa-acl2.elpa
	echo debian/debian-autoloads.el >> debian/elpa-acl2.elpa


debian/acl2-pkg.el: debian/acl2-pkg.el.in
	cat $< | sed "s,@VR@,$$(echo $(VR) | sed 's,[a-zA-Z]*,,g'),g" > $@

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

# debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
# 	cat $< | sed "s,@VR@,$(VR),g" > $@

#pgcl:
#	echo "(progn (setq compiler::*split-files* 100000)(si::save-system \"$@\"))" | GCL_ANSI=t gcl

saved_acl2: # pgcl #debian/patches_applied $(DLOPEN_T)
#	gcl -batch -eval "(bye #-native-reloc 1)" || \
#		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
#	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) GCL_ANSI=t LISP=gcl
	$(MAKE) GCL_MEM_MULTIPLE=0.1 GCL_ANSI=t LISP=$(shell command -v gcl) & j=$$! ; tail --retry -f make.log & k=$$! ; wait $$j ; kill $$k
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
#	These take too much memory when run in parallel
	EXCLUDED_PREFIXES="projects/x86isa/machine/instructions kestrel/x86  kestrel/axe" \
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -j $(NUMJOBS) -l 2.95 regression-fresh 2>&1 | tee $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -l 2.95 regression 2>&1 | tee -a $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#	>$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
#	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
#		for i in $$(find books -name "*.out"); do \
#			if ! [ -e $${i%out}cert ] ; then \
#				echo $$i ; \
#				cat $$i ; \
#			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || true )
	  # gcl -batch -eval \
          #   "(bye \
	  # 	  #-native-reloc 0 \
          #         #+native-reloc \
          #           (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) \
	  # 		 (format t \"certification run with ~s heap words~%\" w) \
	  # 		 (if (< w ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile
	cd books/interface/infix && make -f Makefile example
#	cd books/interface/infix && make -f Makefile events
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied:
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

OVERRIDES:= $(shell find debian/ -name "*.lintian-overrides.in" |sed 's,\.in,,g')

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) clean-all
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2

## acl2 8.6%2Bdfsg

=== books/projects/hol-acl2/lisp/Makefile ===
include $(ACL2_SYSTEM_BOOKS)/Makefile-generic
-include Makefile-deps

=== books/acl2s/aspf/simple-tcp-service/examples/basic-server/Makefile ===
all: build

.PHONY: all clean build

ACL2_EXE ?= ${ACL2_SYSTEM_BOOKS}/../saved_acl2

clean:
	rm -f server server.core

build:
	${ACL2_EXE} < build.lsp

=== books/projects/x86isa/tools/execution/asmtest/Makefile ===


all : snippets.lsp

snippets.lsp : asmtest
	./snippet_table.py lsp

asmtest:

SNIPPET_OBJS := $(patsubst %.nasm,%.o,$(wildcard snippets/*.nasm)) snippets/testgen.o


snippets/%.o : snippets/%.nasm snippets/utils.mac snippets/testgen.nasm
	cd snippets; nasm -f elf64 $*.nasm

%.o : %.c
	gcc -g -c $<

asmtest.o : asmtest.h snippets.h

asmtest: asmtest.o $(SNIPPET_OBJS)
	gcc -g $^ -o asmtest

snippets.h : snippets-combined.txt
	./snippet_table.py h

testgen/testgen:
	cd testgen && make testgen

snippets-generated.txt snippets/testgen.nasm: testgen/testgen
	./testgen/testgen -a snippets/testgen.nasm -t snippets-generated.txt

snippets-combined.txt: snippets-generated.txt
	echo "# Generated file -- do not edit" | cat - snippets.txt snippets-generated.txt > snippets-combined.txt

check-test: snippets.lsp
ifndef ACL2
	$(error Variable ACL2 is undefined.)
endif
	< check-test.lsp $(ACL2)

.PHONY: test
test: check-test snippets.txt asmtest snippets.lsp
	rm -rf inputs outputs results
	mkdir -p inputs outputs
	< snippets-combined.txt sed '/^#/d;/^$$/d' | ./run-tests.sh
	< snippets-combined.txt sed '/^#/d;/^$$/d' | ./get-results.sh

.PHONY: clean
clean:
	pushd testgen && make clean && popd
	rm -rf check-test check-test.lx86cl64 inputs outputs results snippets-generated.txt snippets-combined.txt snippets.lsp asmtest snippets.h asmtest.o $(SNIPPET_OBJS)
